/* Scicos Computational function  */
/*     Generated by Code_Generation toolbox of Scicos with scicos4.4 */
/*     date : 20-Oct-2010 */

/* Copyright (c) 1989-2010 Metalau project INRIA */

/* ---- Headers ---- */
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <machine.h>
#include <os_specific/link.h>
#include <scicos/scicos.h>

 
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define min(a,b) ((a) <= (b) ? (a) : (b))
 

/* prototype of 'signum' (type 4 - with zcross) */
void signum(scicos_block *, int );

/* prototype of 'summation' (type 4) */
void summation(scicos_block *, int );

/* prototype of 'sawtth' (type 0) */
void C2F(sawtth)(int *, int *, double *, double *, double *, int *, double *, \
                 int *, double *, int *, double *, int *,int *, int *, \
                 double *, int *, double *, int *);

/* prototype of 'gainblk' (type 4) */
void gainblk(scicos_block *, int );

/*---------------------------------------- Block Computational function */ 
void SuperBlock(scicos_block *block, int flag)
{

  /* Some general static variables */
  static double zero=0;
  static double w[1];

  /* declaration of local variables for that block struct */
  double* z      = block->z;
  void **ozptr   = block->ozptr;
  void** u       = block->inptr;
  void** y       = block->outptr;
  int nevprt     = block->nevprt;
  double* rpar   = block->rpar;
  /*int nrpar      = block->nrpar;*/
  int* ipar      = block->ipar;
  /*int nipar      = block->nipar;*/
  double* g      = block->g;
  int* jroot     = block->jroot;
  int* mode      = block->mode;
  void **work    = block->work;

  /* time is given in argument of function block */
  double t     = get_scicos_time();

  /* Variables for constant values */
  int nrd_1, nrd_2;

  double *args[100];

  int kf;
  int i;
  int* reentryflag;

  int local_flag;
  void **SuperBlock_block_outtbptr;
  scicos_block *block_SuperBlock;

  /*  work of blocks are catenated at the end of z */
  work = (void **)(z+1);

  /*  SuperBlock_block_outtbptr is catenated at the end of oz */
  SuperBlock_block_outtbptr = (void **)(ozptr+0);

  /* struct of all blocks are stored in work of that block struct */
  block_SuperBlock=(scicos_block*) *block->work;

  /* Copy inputs in the block outtb */
  memcpy(*(SuperBlock_block_outtbptr+4),*(u+0),1*sizeof(double));

  if (flag != 4 && flag != 6 && flag != 5) {

    /* Adjust ptr array of zero crossing */
    block_SuperBlock[0].g    = &(g[0]);
    block_SuperBlock[0].jroot = &(jroot[0]);

    /* set blk struc. of 'signum' (type 4 - blk nb 1) */
    block_SuperBlock[0].inptr[0]  = SuperBlock_block_outtbptr[2];
    block_SuperBlock[0].outptr[0] = SuperBlock_block_outtbptr[3];
    block_SuperBlock[0].mode      = &(mode[0]);

    /* set blk struc. of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].inptr[0]  = SuperBlock_block_outtbptr[1];
    block_SuperBlock[1].inptr[1]  = SuperBlock_block_outtbptr[4];
    block_SuperBlock[1].outptr[0] = SuperBlock_block_outtbptr[2];
    block_SuperBlock[1].rpar      = &(rpar[0]);
    block_SuperBlock[1].ipar      = &(ipar[0]);

    /* set blk struc. of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].outptr[0] = SuperBlock_block_outtbptr[0];
    block_SuperBlock[2].z         = &(z[0]);

    /* set blk struc. of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].inptr[0]  = SuperBlock_block_outtbptr[0];
    block_SuperBlock[3].outptr[0] = SuperBlock_block_outtbptr[1];
    block_SuperBlock[3].rpar      = &(rpar[1]);

    /* set blk struc. of 'actionneur1' (type 0 - blk nb 5) */
    block_SuperBlock[4].inptr[0]  = SuperBlock_block_outtbptr[3];

    /* set blk struc. of 'capteur1' (type 0 - blk nb 6) */
    block_SuperBlock[5].outptr[0] = SuperBlock_block_outtbptr[4];

    /* set blk struc. of 'bidon' (type 0 - blk nb 7) */

    /*  Adjust ptr array that must be done only one times */
    reentryflag=(int*) ((scicos_block *)(*block->work)+7);
    if (*reentryflag==0) {
      *reentryflag=1;

      /* initial blocks must be called with flag 1 */
      /* Call of 'sawtth' (type 0 - blk nb 3) */
      block_SuperBlock[2].nevprt = 0;
      local_flag = 1;
      args[0]=NULL;
      args[1]=(double *)block_SuperBlock[2].outptr[0];
      C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                  block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                  block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                  &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                  block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                  (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
      /* error handling */
      if(local_flag < 0) {
        set_block_error(local_flag);
        return;
      }
    
      /* Call of 'gainblk' (type 4 - blk nb 4) */
      block_SuperBlock[3].nevprt = 1;
      local_flag = 1;
      gainblk(&block_SuperBlock[3],local_flag);
      /* error handling */
      if (get_block_error() < 0) {
        return;
      }
    
      /* Call of 'summation' (type 4 - blk nb 2) */
      block_SuperBlock[1].nevprt = 3;
      local_flag = 1;
      summation(&block_SuperBlock[1],local_flag);
      /* error handling */
      if (get_block_error() < 0) {
        return;
      }
    
      /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
      block_SuperBlock[0].nevprt = 1;
      local_flag = 1;
      signum(&block_SuperBlock[0],local_flag);
      /* error handling */
      if (get_block_error() < 0) {
        return;
      }
    
    }
  }

  if (flag == 0) { /* Continuous state computation */
  
  
  }
  else if (flag == 1) { /* Output computation */
    switch (nevprt) {
      case 0 : /* Blocks activated on the event number 0 */
        /* Call of 'sawtth' (type 0 - blk nb 3) */
        block_SuperBlock[2].nevprt = 0;
        local_flag = 1;
        args[0]=NULL;
        args[1]=(double *)block_SuperBlock[2].outptr[0];
        C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                    block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                    block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                    &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                    block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                    (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
        /* error handling */
        if(local_flag < 0) {
          set_block_error(local_flag);
          return;
        }
    
        /* Call of 'gainblk' (type 4 - blk nb 4) */
        block_SuperBlock[3].nevprt = 1;
        local_flag = 1;
        gainblk(&block_SuperBlock[3],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
        /* Call of 'summation' (type 4 - blk nb 2) */
        block_SuperBlock[1].nevprt = 3;
        local_flag = 1;
        summation(&block_SuperBlock[1],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
        /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
        block_SuperBlock[0].nevprt = 1;
        local_flag = 1;
        signum(&block_SuperBlock[0],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
      break;

      case 1 : /* Blocks activated on the event number 1 */
        /* Call of 'sawtth' (type 0 - blk nb 3) */
        block_SuperBlock[2].nevprt = 1;
        local_flag = 1;
        args[0]=NULL;
        args[1]=(double *)block_SuperBlock[2].outptr[0];
        C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                    block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                    block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                    &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                    block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                    (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
        /* error handling */
        if(local_flag < 0) {
          set_block_error(local_flag);
          return;
        }
    
        /* Call of 'gainblk' (type 4 - blk nb 4) */
        block_SuperBlock[3].nevprt = 1;
        local_flag = 1;
        gainblk(&block_SuperBlock[3],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
        /* Call of 'summation' (type 4 - blk nb 2) */
        block_SuperBlock[1].nevprt = 3;
        local_flag = 1;
        summation(&block_SuperBlock[1],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
        /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
        block_SuperBlock[0].nevprt = 1;
        local_flag = 1;
        signum(&block_SuperBlock[0],local_flag);
        /* error handling */
        if (get_block_error() < 0) {
          return;
        }
    
        /* critical event */
        do_cold_restart();

      break;

    }
  }
  else if ((flag == 2)&&(nevprt>=0)) { /* Discrete state computation */
    switch (nevprt) {
      case 1 : /* Blocks activated on the event number 1 */
        /* Call of 'sawtth' (type 0 - blk nb 3) */
        block_SuperBlock[2].nevprt = 1;
        local_flag = 2;
        args[0]=NULL;
        args[1]=(double *)block_SuperBlock[2].outptr[0];
        C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                    block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                    block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                    &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                    block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                    (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
        /* error handling */
        if(local_flag < 0) {
          set_block_error(local_flag);
          return;
        }
    
        /* critical event */
        do_cold_restart();

      break;

    }
  }
  else if ((flag == 2)&&(nevprt<0)) { /* zero crossing internal events */
    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = -1;
    local_flag = 2;
    signum(&block_SuperBlock[0],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  }
  else if (flag == 9) { /* Update zero crossing surfaces */

    /* Call of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].nevprt = 0;
    local_flag = 1;
    args[0]=NULL;
    args[1]=(double *)block_SuperBlock[2].outptr[0];
    C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
    /* error handling */
    if(local_flag < 0) {
      set_block_error(local_flag);
      return;
    }
  
    /* Call of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].nevprt = 1;
    local_flag = 1;
    gainblk(&block_SuperBlock[3],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  
    /* Call of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].nevprt = 3;
    local_flag = 1;
    summation(&block_SuperBlock[1],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  
    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 1;
    local_flag = 1;
    signum(&block_SuperBlock[0],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  
    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 1;
    local_flag = 9;
    signum(&block_SuperBlock[0],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  
  }
  else if (flag == 4) { /* Initialization */
    /* work array allocation */
    if ((*block->work=scicos_malloc(sizeof(scicos_block)*7+sizeof(int)))== NULL) {
      set_block_error(-16);
      return;
    }
    reentryflag=(int*) ((scicos_block *)(*block->work)+7);
    *reentryflag=0;
    block_SuperBlock=(scicos_block*) *block->work;

    /* set blk struc. of 'signum' (type 4 - blk nb 1) */
    block_SuperBlock[0].type   = 4;
    block_SuperBlock[0].ztyp   = 1;
    block_SuperBlock[0].ng     = 1;
    block_SuperBlock[0].nx     = 0;
    block_SuperBlock[0].x      = &(zero);
    block_SuperBlock[0].xd     = w;
    block_SuperBlock[0].g      = &(g[0]);
    block_SuperBlock[0].mode   = &(mode[0]);
    block_SuperBlock[0].nz     = 0;
    block_SuperBlock[0].noz    = 0;
    block_SuperBlock[0].nrpar  = 0;
    block_SuperBlock[0].nopar  = 0;
    block_SuperBlock[0].nipar  = 0;
    block_SuperBlock[0].nin    = 1;
    block_SuperBlock[0].nout   = 1;
    block_SuperBlock[0].nevout = 0;
    block_SuperBlock[0].nmode  = 1;
    if ((block_SuperBlock[0].evout  = calloc(block_SuperBlock[0].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[0].insz   = malloc(3*sizeof(int)*block_SuperBlock[0].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[0].inptr  = malloc(sizeof(void *)*block_SuperBlock[0].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[0].inptr[0]  = SuperBlock_block_outtbptr[2];
    block_SuperBlock[0].insz[0]   = 1;
    block_SuperBlock[0].insz[1]   = 1;
    block_SuperBlock[0].insz[2]   = SCSREAL_N;
    if ((block_SuperBlock[0].outsz  = malloc(3*sizeof(int)*block_SuperBlock[0].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[0].outptr = malloc(sizeof(void*)*block_SuperBlock[0].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[0].outptr[0] = SuperBlock_block_outtbptr[3];
    block_SuperBlock[0].outsz[0]  = 1;
    block_SuperBlock[0].outsz[1]  = 1;
    block_SuperBlock[0].outsz[2]  = SCSREAL_N;
    block_SuperBlock[0].nevprt    = nevprt;
    block_SuperBlock[0].label     = NULL;

    /* set blk struc. of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].type   = 4;
    block_SuperBlock[1].ztyp   = 0;
    block_SuperBlock[1].ng     = 0;
    block_SuperBlock[1].nx     = 0;
    block_SuperBlock[1].x      = &(zero);
    block_SuperBlock[1].xd     = w;
    block_SuperBlock[1].g      = &(zero);
    block_SuperBlock[1].nz     = 0;
    block_SuperBlock[1].noz    = 0;
    block_SuperBlock[1].nrpar  = 1;
    block_SuperBlock[1].nopar  = 0;
    block_SuperBlock[1].nipar  = 2;
    block_SuperBlock[1].nin    = 2;
    block_SuperBlock[1].nout   = 1;
    block_SuperBlock[1].nevout = 0;
    block_SuperBlock[1].nmode  = 0;
    if ((block_SuperBlock[1].evout  = calloc(block_SuperBlock[1].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[1].insz   = malloc(3*sizeof(int)*block_SuperBlock[1].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[1].inptr  = malloc(sizeof(void *)*block_SuperBlock[1].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[1].inptr[0]  = SuperBlock_block_outtbptr[1];
    block_SuperBlock[1].inptr[1]  = SuperBlock_block_outtbptr[4];
    block_SuperBlock[1].insz[0]   = 1;
    block_SuperBlock[1].insz[1]   = 1;
    block_SuperBlock[1].insz[2]   = 1;
    block_SuperBlock[1].insz[3]   = 1;
    block_SuperBlock[1].insz[4]   = SCSREAL_N;
    block_SuperBlock[1].insz[5]   = SCSREAL_N;
    if ((block_SuperBlock[1].outsz  = malloc(3*sizeof(int)*block_SuperBlock[1].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[1].outptr = malloc(sizeof(void*)*block_SuperBlock[1].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[1].outptr[0] = SuperBlock_block_outtbptr[2];
    block_SuperBlock[1].outsz[0]  = 1;
    block_SuperBlock[1].outsz[1]  = 1;
    block_SuperBlock[1].outsz[2]  = SCSREAL_N;
    block_SuperBlock[1].rpar      = &(rpar[0]);
    block_SuperBlock[1].ipar      = &(ipar[0]);
    block_SuperBlock[1].nevprt    = nevprt;
    block_SuperBlock[1].label     = NULL;

    /* set blk struc. of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].type   = 0;
    block_SuperBlock[2].ztyp   = 0;
    block_SuperBlock[2].ng     = 0;
    block_SuperBlock[2].nx     = 0;
    block_SuperBlock[2].x      = &(zero);
    block_SuperBlock[2].xd     = w;
    block_SuperBlock[2].g      = &(zero);
    block_SuperBlock[2].nz     = 1;
    block_SuperBlock[2].noz    = 0;
    block_SuperBlock[2].nrpar  = 0;
    block_SuperBlock[2].nopar  = 0;
    block_SuperBlock[2].nipar  = 0;
    block_SuperBlock[2].nin    = 0;
    block_SuperBlock[2].nout   = 1;
    block_SuperBlock[2].nevout = 0;
    block_SuperBlock[2].nmode  = 0;
    if ((block_SuperBlock[2].evout  = calloc(block_SuperBlock[2].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[2].outsz  = malloc(3*sizeof(int)*block_SuperBlock[2].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[2].outptr = malloc(sizeof(void*)*block_SuperBlock[2].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[2].outptr[0] = SuperBlock_block_outtbptr[0];
    block_SuperBlock[2].outsz[0]  = 1;
    block_SuperBlock[2].outsz[1]  = 1;
    block_SuperBlock[2].outsz[2]  = SCSREAL_N;
    block_SuperBlock[2].z         = &(z[0]);
    block_SuperBlock[2].nevprt    = nevprt;
    block_SuperBlock[2].label     = NULL;

    /* set blk struc. of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].type   = 4;
    block_SuperBlock[3].ztyp   = 0;
    block_SuperBlock[3].ng     = 0;
    block_SuperBlock[3].nx     = 0;
    block_SuperBlock[3].x      = &(zero);
    block_SuperBlock[3].xd     = w;
    block_SuperBlock[3].g      = &(zero);
    block_SuperBlock[3].nz     = 0;
    block_SuperBlock[3].noz    = 0;
    block_SuperBlock[3].nrpar  = 1;
    block_SuperBlock[3].nopar  = 0;
    block_SuperBlock[3].nipar  = 0;
    block_SuperBlock[3].nin    = 1;
    block_SuperBlock[3].nout   = 1;
    block_SuperBlock[3].nevout = 0;
    block_SuperBlock[3].nmode  = 0;
    if ((block_SuperBlock[3].evout  = calloc(block_SuperBlock[3].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[3].insz   = malloc(3*sizeof(int)*block_SuperBlock[3].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[3].inptr  = malloc(sizeof(void *)*block_SuperBlock[3].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[3].inptr[0]  = SuperBlock_block_outtbptr[0];
    block_SuperBlock[3].insz[0]   = 1;
    block_SuperBlock[3].insz[1]   = 1;
    block_SuperBlock[3].insz[2]   = SCSREAL_N;
    if ((block_SuperBlock[3].outsz  = malloc(3*sizeof(int)*block_SuperBlock[3].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[3].outptr = malloc(sizeof(void*)*block_SuperBlock[3].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[3].outptr[0] = SuperBlock_block_outtbptr[1];
    block_SuperBlock[3].outsz[0]  = 1;
    block_SuperBlock[3].outsz[1]  = 1;
    block_SuperBlock[3].outsz[2]  = SCSREAL_N;
    block_SuperBlock[3].rpar      = &(rpar[1]);
    block_SuperBlock[3].nevprt    = nevprt;
    block_SuperBlock[3].label     = NULL;

    /* set blk struc. of 'actionneur1' (type 0 - blk nb 5) */
    block_SuperBlock[4].type   = 0;
    block_SuperBlock[4].ztyp   = 0;
    block_SuperBlock[4].ng     = 0;
    block_SuperBlock[4].nx     = 0;
    block_SuperBlock[4].x      = &(zero);
    block_SuperBlock[4].xd     = w;
    block_SuperBlock[4].g      = &(zero);
    block_SuperBlock[4].nz     = 0;
    block_SuperBlock[4].noz    = 0;
    block_SuperBlock[4].nrpar  = 0;
    block_SuperBlock[4].nopar  = 0;
    block_SuperBlock[4].nipar  = 1;
    block_SuperBlock[4].nin    = 1;
    block_SuperBlock[4].nout   = 0;
    block_SuperBlock[4].nevout = 0;
    block_SuperBlock[4].nmode  = 0;
    if ((block_SuperBlock[4].evout  = calloc(block_SuperBlock[4].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[4].insz   = malloc(3*sizeof(int)*block_SuperBlock[4].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[4].inptr  = malloc(sizeof(void *)*block_SuperBlock[4].nin))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[4].inptr[0]  = SuperBlock_block_outtbptr[3];
    block_SuperBlock[4].insz[0]   = 1;
    block_SuperBlock[4].insz[1]   = 1;
    block_SuperBlock[4].insz[2]   = SCSREAL_N;
    block_SuperBlock[4].nevprt    = nevprt;
    block_SuperBlock[4].label     = NULL;

    /* set blk struc. of 'capteur1' (type 0 - blk nb 6) */
    block_SuperBlock[5].type   = 0;
    block_SuperBlock[5].ztyp   = 0;
    block_SuperBlock[5].ng     = 0;
    block_SuperBlock[5].nx     = 0;
    block_SuperBlock[5].x      = &(zero);
    block_SuperBlock[5].xd     = w;
    block_SuperBlock[5].g      = &(zero);
    block_SuperBlock[5].nz     = 0;
    block_SuperBlock[5].noz    = 0;
    block_SuperBlock[5].nrpar  = 0;
    block_SuperBlock[5].nopar  = 0;
    block_SuperBlock[5].nipar  = 1;
    block_SuperBlock[5].nin    = 0;
    block_SuperBlock[5].nout   = 1;
    block_SuperBlock[5].nevout = 0;
    block_SuperBlock[5].nmode  = 0;
    if ((block_SuperBlock[5].evout  = calloc(block_SuperBlock[5].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[5].outsz  = malloc(3*sizeof(int)*block_SuperBlock[5].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    if ((block_SuperBlock[5].outptr = malloc(sizeof(void*)*block_SuperBlock[5].nout))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[5].outptr[0] = SuperBlock_block_outtbptr[4];
    block_SuperBlock[5].outsz[0]  = 1;
    block_SuperBlock[5].outsz[1]  = 1;
    block_SuperBlock[5].outsz[2]  = SCSREAL_N;
    block_SuperBlock[5].nevprt    = nevprt;
    block_SuperBlock[5].label     = NULL;

    /* set blk struc. of 'bidon' (type 0 - blk nb 7) */
    block_SuperBlock[6].type   = 0;
    block_SuperBlock[6].ztyp   = 0;
    block_SuperBlock[6].ng     = 0;
    block_SuperBlock[6].nx     = 0;
    block_SuperBlock[6].x      = &(zero);
    block_SuperBlock[6].xd     = w;
    block_SuperBlock[6].g      = &(zero);
    block_SuperBlock[6].nz     = 0;
    block_SuperBlock[6].noz    = 0;
    block_SuperBlock[6].nrpar  = 0;
    block_SuperBlock[6].nopar  = 0;
    block_SuperBlock[6].nipar  = 1;
    block_SuperBlock[6].nin    = 0;
    block_SuperBlock[6].nout   = 0;
    block_SuperBlock[6].nevout = 1;
    block_SuperBlock[6].nmode  = 0;
    if ((block_SuperBlock[6].evout  = calloc(block_SuperBlock[6].nevout,sizeof(double)))== NULL) {
      set_block_error(-16);
      return;
    }
    block_SuperBlock[6].nevprt    = nevprt;
    block_SuperBlock[6].label     = NULL;

    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 0;
    local_flag = 4;
    signum(&block_SuperBlock[0],local_flag);

    /* Call of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].nevprt = 0;
    local_flag = 4;
    summation(&block_SuperBlock[1],local_flag);

    /* Call of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].nevprt = 0;
    local_flag = 4;
    args[0]=NULL;
    args[1]=(double *)block_SuperBlock[2].outptr[0];
    C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
    /* error handling */
    if(local_flag < 0) {
      set_block_error(local_flag);
    }

    /* Call of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].nevprt = 0;
    local_flag = 4;
    gainblk(&block_SuperBlock[3],local_flag);

    /* error handling */
    if (get_block_error() < 0) {
      return;
    }

    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 0;
    local_flag = 6;
    signum(&block_SuperBlock[0],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }

    /* Call of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].nevprt = 0;
    local_flag = 6;
    summation(&block_SuperBlock[1],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }

    /* Call of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].nevprt = 0;
    local_flag = 6;
    args[0]=NULL;
    args[1]=(double *)block_SuperBlock[2].outptr[0];
    C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
    /* error handling */
    if(local_flag < 0) {
      set_block_error(local_flag);
      return;
    }

    /* Call of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].nevprt = 0;
    local_flag = 6;
    gainblk(&block_SuperBlock[3],local_flag);
    /* error handling */
    if (get_block_error() < 0) {
      return;
    }
  }
  else if (flag == 5) { /* Ending */
    /* get work ptr of that block */
    block_SuperBlock=*block->work;

    /* set blk struc. of 'signum' (type 4 - blk nb 1) */
    block_SuperBlock[0].inptr[0]  = SuperBlock_block_outtbptr[2];
    block_SuperBlock[0].outptr[0] = SuperBlock_block_outtbptr[3];

    /* set blk struc. of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].inptr[0]  = SuperBlock_block_outtbptr[1];
    block_SuperBlock[1].inptr[1]  = SuperBlock_block_outtbptr[4];
    block_SuperBlock[1].outptr[0] = SuperBlock_block_outtbptr[2];
    block_SuperBlock[1].rpar   = &(rpar[0]);
    block_SuperBlock[1].ipar   = &(ipar[0]);

    /* set blk struc. of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].outptr[0] = SuperBlock_block_outtbptr[0];
    block_SuperBlock[2].z         = &(z[0]);

    /* set blk struc. of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].inptr[0]  = SuperBlock_block_outtbptr[0];
    block_SuperBlock[3].outptr[0] = SuperBlock_block_outtbptr[1];
    block_SuperBlock[3].rpar   = &(rpar[1]);

    /* set blk struc. of 'actionneur1' (type 0 - blk nb 5) */
    block_SuperBlock[4].inptr[0]  = SuperBlock_block_outtbptr[3];

    /* set blk struc. of 'capteur1' (type 0 - blk nb 6) */
    block_SuperBlock[5].outptr[0] = SuperBlock_block_outtbptr[4];

    /* set blk struc. of 'bidon' (type 0 - blk nb 7) */

    /* Call of 'signum' (type 4 - blk nb 1 - with zcross) */
    block_SuperBlock[0].nevprt = 0;
    local_flag = 5;
    signum(&block_SuperBlock[0],local_flag);

    /* Call of 'summation' (type 4 - blk nb 2) */
    block_SuperBlock[1].nevprt = 0;
    local_flag = 5;
    summation(&block_SuperBlock[1],local_flag);

    /* Call of 'sawtth' (type 0 - blk nb 3) */
    block_SuperBlock[2].nevprt = 0;
    local_flag = 5;
    args[0]=NULL;
    args[1]=(double *)block_SuperBlock[2].outptr[0];
    C2F(sawtth)(&local_flag,&block_SuperBlock[2].nevprt,&t,block_SuperBlock[2].xd, \
                block_SuperBlock[2].x,&block_SuperBlock[2].nx, \
                block_SuperBlock[2].z,&block_SuperBlock[2].nz,block_SuperBlock[2].evout, \
                &block_SuperBlock[2].nevout,block_SuperBlock[2].rpar,&block_SuperBlock[2].nrpar, \
                block_SuperBlock[2].ipar,&block_SuperBlock[2].nipar, \
                (double *)args[0],(nrd_1=0,&nrd_1),(double *)args[1],(nrd_2=1,&nrd_2));
    /* error handling */
    if(local_flag < 0) {
      set_block_error(local_flag);
    }

    /* Call of 'gainblk' (type 4 - blk nb 4) */
    block_SuperBlock[3].nevprt = 0;
    local_flag = 5;
    gainblk(&block_SuperBlock[3],local_flag);

    for (kf = 0; kf < 7; ++kf){
      if (block_SuperBlock[kf].nin!=0){
        if (block_SuperBlock[kf].insz!=NULL){
          free(block_SuperBlock[kf].insz);
        }
      }
      if (block_SuperBlock[kf].nout!=0){
        if (block_SuperBlock[kf].outsz!=NULL){
          free(block_SuperBlock[kf].outsz);
        }
      }
      if (block_SuperBlock[kf].nopar!=0){
        if (block_SuperBlock[kf].oparptr!=NULL){
          free(block_SuperBlock[kf].oparptr);
        }
        if (block_SuperBlock[kf].oparsz!=NULL){
          free(block_SuperBlock[kf].oparsz);
        }
        if (block_SuperBlock[kf].opartyp!=NULL){
          free(block_SuperBlock[kf].opartyp);
        }
      }
      if (block_SuperBlock[kf].noz!=0){
        if (block_SuperBlock[kf].ozptr!=NULL){
          free(block_SuperBlock[kf].ozptr);
        }
        if (block_SuperBlock[kf].ozsz!=NULL){
          free(block_SuperBlock[kf].ozsz);
        }
        if (block_SuperBlock[kf].oztyp!=NULL){
          free(block_SuperBlock[kf].oztyp);
        }
      }
      if (block_SuperBlock[kf].evout!=NULL){
        free(block_SuperBlock[kf].evout);
      }
      if (block_SuperBlock[kf].label!=NULL){
        free(block_SuperBlock[kf].label);
      }
    }
    scicos_free(block_SuperBlock);
  }

  memcpy(*(y+0),*(SuperBlock_block_outtbptr+3),1*sizeof(double));
  return;

} /* SuperBlock */
